/* Header file for libfi2_a v1.20 (c)1998-1999 Thierry Godefroy. */

#ifndef _FI2_H

#define _FI2_H

/* We must include sys/qlib.h here because we need the QLSTR_t type...
   So we fool sys/qlib.h by making it believe it is included by qdos.h
*/

#ifndef _QDOS_H
#ifndef _SMS_H
#ifndef _QPTR_H
#define _QDOS_H
#include <sys/qlib.h>
#undef _QDOS_H
#endif
#endif
#endif

#ifdef __STDC__
#define _P_(params) params
#else
#define _P_(params)
#endif

/* Types and defines */

#define ACTION_MAX_LENGTH   41
#define FI2_PAR_MARKER      "<<%FI2>>"

typedef struct FI2INFO {
    char            data_id[6]; /* FileInfo II database Id */
    unsigned short  max_key;    /* Maximum key value allowed */
    unsigned short  bitmap;     /* Bitmap of implemented facilities */
    char *          copyright;  /* Pointer on copyright string */
    } FI2INFO_t;

typedef struct FI2ACTION {
    short           type;       /* Action type */
    unsigned short  flags;      /* Action flags */
    const QLSTR_t * name;       /* Pointer on action name */
    const QLSTR_t * job;        /* Pointer on mandatory/forbidden job name */
    const QLSTR_t * thing;      /* Pointer on associated thing name */
    const QLSTR_t * exec;       /* Pointer on associated executable file name */
    const QLSTR_t * command;    /* Pointer on associated command string */
    void *          address;    /* Absolute address of this action bloc */
    } FI2ACTION_t;

/* Functions prototypes */

int fi2_info _P_((FI2INFO_t * fi2));
int fi2_call _P_((chanid_t con_id, int key, char * filename));
int fi2_actn _P_((char * filename, short * actions, void ** act_array));
int fi2_scan _P_((char * ext, short * actions, char * next_ext, int flag, \
                  void ** act_array));
int fi2_parm _P_((void * act_array, int param_code, int act_idx, \
                  short * act_type, unsigned short * act_flags, \
                  char * act_param));
int fi2_allp _P_((void * act_array, int act_idx, FI2ACTION_t * act_bloc));
int fi2_free _P_((void * act_array));
int fi2_data _P_((void * data_bloc, void ** old_data));
int fi2_make _P_((char * ext, char * data_id, FI2ACTION_t * act_bloc));
int fi2_link _P_((char * ext, void * address));
int fi2_unlk _P_((char * ext));
int fi2_load _P_((chanid_t data_file, void ** data_bloc, void ** old_data));
int fi2_save _P_((chanid_t dest_file, int save_key));
int fi2_hctl _P_((short * flags));
int fi2_hmax _P_((short * records));
int fi2_hclr _P_((void));
int fi2_hget _P_((int param_code, short * record_number, char * record_param));
int fi2_hmnu _P_((short * record_number));
int fi2_redo _P_((chanid_t con_id, int key, short record_number));
int fi2_htdy _P_((void));
int fi2_thrd _P_((chanid_t con_id, timeout_t delay, int priority, \
                  char * command_string));

#undef _P_

#endif  /* _FI2_H */
